<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */
class Glace_Glacesys_Model_Observer extends Glace_Glacesys_Abstract_Model
{
    /**
     * @var bool
     */
    protected $_correctionDone = false;
    
    /**
     * Corrects modules' status and launches install/uninstall scripts if some module was enabled/disabled through xml.
     */
    public function correction()
    {
        if (!$this->_correctionDone) {
            $this->tool()->platform()->getModules(); // load modules
            if ($this->tool()->platform()->isNeedCorrection()) {
                $glacesysModel = new Glace_Glacesys_Model_Glacesys(); 
                $glacesysModel->correction(); 
            }
            $this->_correctionDone = true;
        }
    }
    
    public function errorRender()
    {
        $this->tool()->platform()->renderAdminError(true);
    }
    
    /**
     * Replacement for an old abstract rewrite necessary for some extensions.
     * Compatible with Magento CE 1.4.1+
     * 
     * @param Varien_Object $observer
     */
    public function compatibility($observer)
    {
        if (version_compare(Mage::getVersion(), '1.4.1.0', 'ge')) {
            Mage::dispatchEvent('glacesys_block_abstract_to_html_after', $observer->getData());
        }
    }

    /**
     * Update news from www.glace.com
     */
    public function updateNews()
    {
        $news = new Glace_Glacesys_Model_News_Recent();
        $news->loadData();
        
        $important = new Glace_Glacesys_Model_News_Important();
        $important->loadData();
    }
}