<?php
/**
 * CMSIDEAS Booster 1.4+
 *
 * @category:    Glace
 * @package:     Glace_Fullpagecache
 * @version      4.0.5
 * @license:     2JdDLFBgG8MB66INOyv5GmAo6UTrHeVWKTMpmCSWpv
 * @copyright:   Copyright (c) 2013 CMSIDEAS, Inc. (http://www.glace.com)
 */
/**
 * @copyright  Copyright (c) 2010 CMSIDEAS, Inc. 
 */
class Glace_Fullpagecache_Helper_License extends Glace_Glacesys_Helper_License
{
	protected $sCacheConfig = '';
	
	public function __construct()
	{
        $this->sCacheConfig = Mage::app()->getConfig()->getOptions()->getBaseDir() . DS . 'glacebooster' . DS . 'use_cache.ser';
    }

    public function uninstallBefore()
    {
    	$allTypes = Mage::app()->useCache();
        $allTypes['fullpagecache'] = 0;
        Mage::app()->saveUseCache($allTypes);
    	
        $this->writeUseCacheData(0);
    	
    	//Mage::getSingleton('adminhtml/session')->addNotice(Mage::helper('adminhtml')->__('Please do not forget to restore the original index.php from the backup.'));
    }
    
    public function installBefore()
    {
    	$allTypes = Mage::app()->useCache();
        $allTypes['fullpagecache'] = 0;
        Mage::app()->saveUseCache($allTypes);
        
        if(!function_exists('ait_cache_getFilePath'))
        {
            $error = Mage::helper('adminhtml')->__('CMSIDEAS Booster: file "/index.php" is not replaced. Back up your index.php file and copy new index.php from the /glacebooster/ folder to the root directory of your Magento installation.' );
            Mage::getSingleton('adminhtml/session')->addError($error);
        }
    }
    
	protected function writeUseCacheData($enabled = 1)
	{
        try
        {
            return file_put_contents($this->sCacheConfig, serialize(
                array(
                    'fullpagecache' => (int)$enabled,
                    Glace_Fullpagecache_Mainpage::QUOTE_VALUE => (bool)Mage::getStoreConfig('fullpagecache/config/enable_for_quote'),
                    Glace_Fullpagecache_Mainpage::LOGIN_VALUE   => (bool)Mage::getStoreConfig('fullpagecache/config/enable_for_logined')
                )
            ));
        }
        catch (Exception $e)
        {
            return false;
        }
    }
}