<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */

class Glace_Fullpagecache_Model_Config_Cron extends Mage_Core_Model_Config_Data
{
	protected function _afterSave(){

        $cronStringPath = 'crontab/jobs/fullpagecache_clear_cache/schedule/cron_expr';
        $cronModelPath = 'crontab/jobs/fullpagecache_clear_cache/run/model';

        $value = $this->getData('groups/fullpagecache_config_cron/fields/fullpagecache_config_cron_frequency/value');
        
        if(!Mage::helper('fullpagecache')->isValidCronExpr($value))
            Mage::throwException('The format of cron expression is invalid');
        
        try{
        Mage::getModel('core/config_data')
             ->load($cronStringPath, 'path')
            ->setValue($value)
            ->setPath($cronStringPath)
            ->save();
        Mage::getModel('core/config_data')
            ->load($cronModelPath, 'path')
            ->setValue((string) Mage::getConfig()->getNode($cronModelPath))
            ->setPath($cronModelPath)
            ->save();
            }
        catch (Exception $e) {
            Mage::throwException('Unable to save the cron expression.');
        }
        }
}