<?php
/*
 * Developer: Michael Jacky
 * Team site: http://vnextensions.com/
 * Support: http://support.vnextensions.com/
 * 
 */

class Glace_Fullpagecache_Model_Rewrite_CoreCache extends Mage_Core_Model_Cache
{
    public function __construct(array $options = array())
    {
        $this->_defaultBackendOptions['cache_dir'] = Mage::getBaseDir('cache');
        /**
         * Initialize id prefix
         */
        $this->_idPrefix = isset($options['id_prefix']) ? $options['id_prefix'] : '';
        if (!$this->_idPrefix && isset($options['prefix'])) {
            $this->_idPrefix = $options['prefix'];
        }
        if (empty($this->_idPrefix)) {
            $this->_idPrefix = substr(md5(Mage::getConfig()->getOptions()->getEtcDir()), 0, 3).'_';
        }

        $backend    = $this->_getBackendOptions($options);
        $frontend   = $this->_getFrontendOptions($options);

        // <<< CMSIDEAS UPDATE START
        $class = 'Varien_Cache_Core';
        if (class_exists('Glace_Fullpagecache_Mainpage',false))
        {
            $mainpage = Glace_Fullpagecache_Mainpage::getInstance(Mage::getBaseDir());
            if($mainpage->isModuleEnabled()) {
                $class = 'Glace_Fullpagecache_Varien_Cache_Core';
            }
        }    
        
        $this->_frontend = Zend_Cache::factory($class, $backend['type'], $frontend, $backend['options'],
            true, true, true
        );
        // >>> CMSIDEAS UPDATE END

        if (isset($options['request_processors'])) {
            $this->_requestProcessors = $options['request_processors'];
        }

        if (isset($options['disallow_save'])) {
            $this->_disallowSave = $options['disallow_save'];
        }
    }

}